#include <iostream>
#include <vector>
#include <curl/curl.h>
#include "histogram.h"
#include "text.h"
#include "svg.h"
using namespace std;
const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data(istream& in, bool prompt) {
    size_t number_count;
    if (prompt == true){
        cerr << "input number count";
        in >> number_count;
        Input inn;
        inn.numbers.resize(number_count);
        cerr << "input numbers";
        for (size_t i = 0; i < number_count; i++) {
            cin >> inn.numbers[i];
        }
        cerr << "input bin count";
        in >> inn.bin_count;
        return inn;
    }
    else{
        cout << "input number count";
        in >> number_count;
        Input inn;
        inn.numbers.resize(number_count);
        cout << "input numbers";
        for (size_t i = 0; i < number_count; i++) {
            cin >> inn.numbers[i];
        }
        cerr << "input bin count";
        in >> inn.bin_count;
        return inn;
    }
}

int
main(int argc, char* argv[]){
    CURL *curl = curl_easy_init();
    if (argc>1){
        if(curl) {
            CURLcode res;
            curl_easy_setopt(curl, CURLOPT_URL, argv[1]);
            res = curl_easy_perform(curl);
            curl_easy_cleanup(curl);
        }
        return 0;
    }
    curl_global_init(CURL_GLOBAL_ALL);
    auto in = input_data(cin,true);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins);
    return 0;
}
